unit holiday_jp;

interface

function IsHoliday(Year, Month, Day: Integer): Boolean;

implementation

uses NDate;

function IsHoliday(Year, Month, Day: Integer): Boolean;
var
  wd: Integer;
begin
  Result := False;
  wd := WeekDay(Year, Month, Day);
  case Month of
    1: Result := (Day = 1) or ((Day >= 8) and (Day <= 14) and (wd = 0));
    2: Result := Day = 11;
    3: Result := Day = Trunc(20.8431+0.242194*(Year-1980)-Trunc((Year-1980)/4));
    4: Result := Day = 29;
    5: Result := (Day = 3) or (Day = 4) or (Day = 5);
    7: Result := (Day >= 15) and (Day <= 21) and (wd = 0);
    9: Result := ((Day >= 15) and (Day <= 21) and (wd = 0)) or
        (Day = Trunc(23.2488+0.242194*(Year-1980)-Trunc((Year-1980)/4)));
    10: Result := (Day >= 8) and (Day <= 14) and (wd = 0);
    11: Result := (Day = 3) or (Day = 23);
    12: Result := Day = 23;
  end;
end;

end.
