unit NDate;

interface

function IsLeap(Year: Integer): Boolean;
function DaysInMonth(Year, Month: Integer): Integer;
function Weekday(Year, Month, Day: Integer): Integer;

implementation

function IsLeap(Year: Integer): Boolean;
begin
  Result := (Year mod 4 = 0) and ((Year mod 100 <> 0) or (Year mod 400 = 0));
end;

function DaysBeforeMonth(Year, Month: Integer): Integer;
const
  tab: array[1..12] of Integer = (
    0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334
  );
begin
  Result := tab[Month];
  if (Month > 2) and IsLeap(Year) then
    Inc(Result);
end;

function DaysInMonth(Year, Month: Integer): Integer;
const
  tab: array[1..12] of Integer = (
    31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
  );
begin
  if (Month = 2) and IsLeap(Year) then
    Result := 29
  else
    Result := tab[Month];
end;

function Weekday(Year, Month, Day: Integer): Integer;
var
  y, days: Integer;
begin
  y := Year - 1;
  days := y*365 + y div 4 - y div 100 + y div 400 + 
          DaysBeforeMonth(Year, Month) + Day;
  Result := (days + 6) mod 7;
end;

end.
